/* ntree.c
   E.V. may 99
   parsing e printout su un albero n-ario
   rappresentazione con lista dei sucecssori
*/

#include<conio.h>
#include<stdlib.h>

typedef int boolean;
#define true 1
#define false 0

struct ntree{
  char value;
  struct list * next_ptr;
};

struct list{
  struct ntree * node_ptr;
  struct list * next_ptr;
};

void main(void);
/* costruisce un albero e lo visita*/

void parse(struct ntree ** root_ptr_ptr);
/* */

void printout(struct ntree * root_ptr);

void main(void)
/* costruisce un albero e lo visita*/
{
   struct ntree * root_ptr;
   char ch;

   printf("\n");
   do{
      ch=getche();
   }while(ch!='(');

   parse(&root_ptr);

   printf("\n");
   /* evita che l'i/o formattato di printf() sia impastato da getche  */

   printout(root_ptr);
}

void parse(struct ntree ** root_ptr_ptr)
/* esegue il parsing di una sequenza di caratteri
   che codificano un albero n-ario in notazione parentetica
   assume che l'albero inizi con il carattere della radice
   ignora i caratteri illegali
   non considera illegale la parentesi come carattere
*/
{
   boolean no_more_children;
   char  ch;
   struct list ** list_ptr_ptr;

   /* inserisci la radice */
   ch=getche();
   *root_ptr_ptr=(struct ntree *)malloc(sizeof(struct ntree));
   (*root_ptr_ptr)->value=ch;
   (*root_ptr_ptr)->next_ptr=NULL;

   /* inserisci i figli */
   no_more_children=false;
   list_ptr_ptr=&((*root_ptr_ptr)->next_ptr);
   do{
      ch=getche();
      if(ch==')')
        no_more_children=true;
      else if(ch=='(')
      {
        *list_ptr_ptr=(struct list *)malloc(sizeof(struct list));
        (*list_ptr_ptr)->next_ptr=NULL;
        (*list_ptr_ptr)->node_ptr=(struct ntree *)malloc(sizeof(struct ntree));
        parse(&((*list_ptr_ptr)->node_ptr));
        list_ptr_ptr=&((*list_ptr_ptr)->next_ptr);
      }
   }while(no_more_children==false);
}


void printout(struct ntree * root_ptr)
/* assume che root_ptr!=NULL*/
{
   struct list * list_ptr;

   printf("(");
   printf("%c",root_ptr->value);
   list_ptr=root_ptr->next_ptr;
   while(list_ptr!=NULL)
   {  printout(list_ptr->node_ptr);
      list_ptr=list_ptr->next_ptr;
   }
   printf(")");
}
